/* global NodeJS */
import fileSystem from "node:fs";
function getIsNonEmptyString(line) {
    return line.trim() !== "";
}
function makeTypingLine(line) {
    var _a, _b;
    if (!/export var\s+\S+?\s*=\s*\S+?;/u.test(line)) {
        return "";
    }
    const exportKey = (_b = (_a = line.replace("export var ", "").split("=").at(0)) === null || _a === void 0 ? void 0 : _a.trim()) !== null && _b !== void 0 ? _b : "";
    if (exportKey === "") {
        return "";
    }
    return `export const ${exportKey}: string;`;
}
function writeFileCallback(error) {
    if (error) {
        console.error(error);
    }
}
function getTypingContent(source) {
    const exportList = source
        .split("\n")
        .map(makeTypingLine)
        .filter(getIsNonEmptyString);
    return `// Do not change. This file is automatically generated.\n${exportList.join("\n")}\n`;
}
export function cssModuleTypescriptLoader(source) {
    // eslint-disable-next-line babel/no-invalid-this
    const pathToNewFile = `${this.resourcePath}.d.ts`;
    fileSystem.writeFile(pathToNewFile, getTypingContent(source), writeFileCallback);
    return source;
}
//# sourceMappingURL=css-module-typescript-loader.js.map